package operationword;

import java.util.Vector;
import java.sql.ResultSet;
import java.net.URL;
/*
 //mail 1.1.3
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.Message;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.InternetAddress;
import java.util.Properties;
*/

//mail 1.3
 /*
import java.util.*;
import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
*/


/**
 * <p>Title: </p>
 * <p>Description: This class controls the operation word test procedure
 * totalTestItem is 60 now
 * There are totally 5 levels level2-6, in level2, after 2 ops and 2 words, tests are given.
 * In each level, there are 3 series, so there are totally 15 series (serOrder[0] - serOrder[14]).
 * </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author tylin
 * @version 1.0
 */

public class Controller {
  boolean debug = false;
  int totalTestItem = 60; //total test strings
  int currentItem=-2; //current item out of totalTestItem, start from -2 because of 2 practice
  DBManager db;
  OWInterface owInterface;
  int step = -5; //this variable control the step to run in start()
  DisplayPanel display;
  TestPanel test;
  MessagePanel message;
  //Word word = new Word();
  Word word;
  Operation operation = new Operation(totalTestItem);
  String[] wordList;
  String[] operationList;
  boolean[] trueFalseList;
  String[] wordReply = new String[totalTestItem]; //reply of words from a user
  boolean[] trueFalseReply = new boolean[totalTestItem]; //true false reply (about operation) from a user
  String studentID;
  long startTime =0; //start time (millisecond) for each testItem
  long endTime=0; //end time for each item
  long totalLatency=0; //total latency sum(startTime - endTime)
  boolean isAdmin = false; //whether this student is a admin or not
  int wordSet;
  String usertestsTable;
  boolean enforceDBCheck = true;


  //4 is 1st series, 1 is second series
  int[] serOrder  = {4, 1, 7, 13, 5, 10, 2, 14, 11, 3, 8, 12, 9, 6, 15}; //random order of series except the first 2
  //1,2,3 has size=2, 4,5,6 has setsize=3, ...
  int[] serSize  = {3, 2, 4, 6, 3, 5, 2, 6, 5, 2, 4, 5, 4, 3, 6};

  int processingMeasure = 0; //number of correct verification
  int setSizeMemorySpan =0; //manximum size of the set of to-be-remembered item
  int totalMemorySpan = 0; //total number of correctly recorded words/digit
  long averageLatency = 0;
  int partialCorrectWords =0; //words answered in correct spelling, correct position, but not all 2-6 words in the set are all corrected recalled
  boolean practiceMode = false;

  public Controller(OWInterface pOw, String pServer, String pUser, String pPw, String pDBName, int pWordSet, String pusertestsTable, boolean pEnforceDBCheck) {
    for (int i =0;i<this.totalTestItem;i++){
      wordReply[i]="";
    }
    this.usertestsTable = pusertestsTable;
    this.owInterface = pOw;
    this.wordSet = pWordSet;
    this.enforceDBCheck = pEnforceDBCheck;
    try{
      db = new DBManager(pServer, pUser, pPw, pDBName, enforceDBCheck);
    }catch(Exception e){
      e.printStackTrace();
      step = 99;
      String msg = "Connection to database failed. The firewall in your institution (university) may block access to the required port (3306) to our database server. Please try to acceess Web-OSPAN again from another location (e.g. your home). Please close this window.";
      message = new MessagePanel(this, msg);
      this.owInterface.ChangePanel(message);
    }

    //System.out.println(pServer + pUser+ pPw+ pDBName);

    word = new Word(pWordSet);
    wordList = word.getNoRepeatWords(totalTestItem);
    operationList = operation.operationArray;
    trueFalseList = operation.answerArray;

 }

 public void setStudentID(String pStudentID){
   this.studentID = pStudentID;
   String query = "select isAdmin from users where userID='" + this.studentID + "';";
   ResultSet rs = db.getResultSet(query);
   try{
     if(rs.next()){
       String admin = rs.getString("isAdmin");
       if (admin.compareTo("y") == 0) {
         this.isAdmin = true;
       }
     }

   }catch(Exception e){
     e.printStackTrace();
   }
 }


  /**
   * start the operation word procedure
   * step starts with -5
   */
  public void nextStep(){
    //1 message (say practice start), 2 practice, 1 test, and then 1 message (saying test start)
    if(!practiceMode){
      if (this.startTime != 0) {
        this.totalLatency += this.endTime - this.startTime;
      }
    }

    step++; //go to next step
    //Timer t;
    this.startTime =0;
    //******** test
     /*
     try{
       URL url = new URL(this.owInterface.getCodeBase().toString() + "mail.php");
       System.out.println(url.toString());
     }catch(Exception ex){
       ex.printStackTrace();
     }
*/
    //**********
    String msg = this.word.practiceString;
    try{
      switch(this.step){
        case -4:
          this.practiceMode = true;
          message = new MessagePanel(this, msg);
          this.owInterface.ChangePanel(message);
          break;
        case -3:
          display = new DisplayPanel(this, " (2 x 2) + 4 = 8", this.word.practiceWord1);
          this.owInterface.ChangePanel(display);
          break;
        case -2:
          display = new DisplayPanel(this, " (9 / 3) + 1 = 9", this.word.practiceWord2);
          this.owInterface.ChangePanel(display);
          break;
        case -1:
          test = new TestPanel(2, this, 0); //0-2
          this.owInterface.ChangePanel(test);
          break;
        case 0:
          message = new MessagePanel(this, word.endPractice);
          this.owInterface.ChangePanel(message);
          break;

        //1st series
        case 1:
          practiceMode = false;
          display = new DisplayPanel(this, 0);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 2:
          display = new DisplayPanel(this, 1);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 3:
          display = new DisplayPanel(this, 2);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 4:
          test = new TestPanel(3, this, 0); //0-2
          this.owInterface.ChangePanel(test);
          break;

        //2nd series
        case 5:
          display = new DisplayPanel(this, 3);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 6:
          display = new DisplayPanel(this, 4);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 7:
          test = new TestPanel(2, this, 3); //3-4
          this.owInterface.ChangePanel(test);
          break;

        //3rd series
        case 8:
          display = new DisplayPanel(this, 5);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 9:
          display = new DisplayPanel(this, 6);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 10:
         display = new DisplayPanel(this, 7);
         this.owInterface.ChangePanel(display);
         this.startTime = System.currentTimeMillis();
         break;
       case 11:
         display = new DisplayPanel(this, 8);
         this.owInterface.ChangePanel(display);
         this.startTime = System.currentTimeMillis();
         break;
       case 12:
         test = new TestPanel(4, this, 5); //5-8
         this.owInterface.ChangePanel(test);
         break;

         //4th series
        case 13:
          display = new DisplayPanel(this, 9);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 14:
          display = new DisplayPanel(this, 10);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 15:
          display = new DisplayPanel(this, 11);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 16:
          display = new DisplayPanel(this, 12);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 17:
          display = new DisplayPanel(this, 13);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 18:
          display = new DisplayPanel(this, 14);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 19:
          test = new TestPanel(6, this, 9); //9-14
          this.owInterface.ChangePanel(test);
          break;

          //5th series
        case 20:
          display = new DisplayPanel(this, 15);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 21:
          display = new DisplayPanel(this, 16);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 22:
          display = new DisplayPanel(this, 17);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 23:
          test = new TestPanel(3, this, 15); //15-17
          this.owInterface.ChangePanel(test);
          break;

          //6th series
        case 24:
          display = new DisplayPanel(this, 18);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 25:
          display = new DisplayPanel(this, 19);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 26:
          display = new DisplayPanel(this, 20);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 27:
          display = new DisplayPanel(this, 21);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 28:
          display = new DisplayPanel(this, 22);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 29:
          test = new TestPanel(5, this, 18); //18-22
          this.owInterface.ChangePanel(test);
          break;

          //7th series
        case 30:
          display = new DisplayPanel(this, 23);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 31:
          display = new DisplayPanel(this, 24);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 32:
          test = new TestPanel(2, this, 23); //23-24
          this.owInterface.ChangePanel(test);
          break;

          //8th series
        case 33:
          display = new DisplayPanel(this, 25);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 34:
          display = new DisplayPanel(this, 26);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 35:
          display = new DisplayPanel(this, 27);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 36:
          display = new DisplayPanel(this, 28);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 37:
          display = new DisplayPanel(this, 29);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 38:
          display = new DisplayPanel(this, 30);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 39:
          test = new TestPanel(6, this, 25); //25-30
          this.owInterface.ChangePanel(test);
          break;

          //9th series
        case 40:
          display = new DisplayPanel(this, 31);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 41:
          display = new DisplayPanel(this, 32);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 42:
          display = new DisplayPanel(this, 33);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 43:
          display = new DisplayPanel(this, 34);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 44:
          display = new DisplayPanel(this, 35);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 45:
          test = new TestPanel(5, this, 31); //31-35
          this.owInterface.ChangePanel(test);
          break;

          //10th series
        case 46:
          display = new DisplayPanel(this, 36);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 47:
          display = new DisplayPanel(this, 37);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 48:
          test = new TestPanel(2, this, 36); //36-37
          this.owInterface.ChangePanel(test);
          break;

          //11th series
        case 49:
          display = new DisplayPanel(this, 38);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 50:
          display = new DisplayPanel(this, 39);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 51:
          display = new DisplayPanel(this, 40);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 52:
          display = new DisplayPanel(this, 41);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 53:
          test = new TestPanel(4, this, 38); //38-41
          this.owInterface.ChangePanel(test);
          break;

          //12th series
        case 54:
          display = new DisplayPanel(this, 42);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 55:
          display = new DisplayPanel(this, 43);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 56:
          display = new DisplayPanel(this, 44);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 57:
          display = new DisplayPanel(this, 45);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 58:
          display = new DisplayPanel(this, 46);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 59:
          test = new TestPanel(5, this, 42); //42-46
          this.owInterface.ChangePanel(test);
          break;

          //13th series
        case 60:
          display = new DisplayPanel(this, 47);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 61:
          display = new DisplayPanel(this, 48);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 62:
          display = new DisplayPanel(this, 49);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 63:
          display = new DisplayPanel(this, 50);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 64:
          test = new TestPanel(4, this, 47); //47-50
          this.owInterface.ChangePanel(test);
          break;

          //14th series
        case 65:
          display = new DisplayPanel(this, 51);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 66:
          display = new DisplayPanel(this, 52);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 67:
          display = new DisplayPanel(this, 53);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 68:
          test = new TestPanel(3, this, 51); //51-55
          this.owInterface.ChangePanel(test);
          break;

          //15th series
        case 69:
          display = new DisplayPanel(this, 54);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 70:
          display = new DisplayPanel(this, 55);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 71:
          display = new DisplayPanel(this, 56);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 72:
          display = new DisplayPanel(this, 57);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 73:
          display = new DisplayPanel(this, 48);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 74:
          display = new DisplayPanel(this, 59);
          this.owInterface.ChangePanel(display);
          this.startTime = System.currentTimeMillis();
          break;
        case 75:
          test = new TestPanel(6, this, 54); //54-59
          this.owInterface.ChangePanel(test);
          break;
        case 76:
          //this.endTime = System.currentTimeMillis();
          calculateTotal();
          msg =
            word.end1 +
            word.arithmetic + this.processingMeasure +
            "\n" +
            word.ospan + this.totalMemorySpan +
            "\n" +
            word.setSize + this.setSizeMemorySpan +
            "\n" +
            word.latency + this.averageLatency + "\n\n";

          if (this.totalMemorySpan > 31.33) {
            msg = msg + word.adviceLow;
          }
          else {
            msg = msg + word.adviceHigh;
          }




          if(this.owInterface.emailToAdmin){
            //******* email
             String strURL = this.owInterface.getCodeBase().toString() +
               "zMail.php" +
               "?procMeasure=" + this.processingMeasure + "&memSpan=" +
               this.totalMemorySpan +
               "&setSize=" + this.setSizeMemorySpan + "&avgLatency=" +
               this.averageLatency +
               "&userID=" + this.studentID +
               "&partialWord=" + this.partialCorrectWords;
            URL url = new URL(strURL);
            System.out.println(url.toString());
            this.owInterface.getAppletContext().showDocument(url, "_blank");
            //*******email end
          }

          message = new MessagePanel(this, msg);
          message.butOK.setVisible(false);
          this.owInterface.ChangePanel(message);



          break;


      }//end switch
    }catch(Exception e){
      if(e.toString().compareTo("java.net.MalformedURLException")==0){
         message = new MessagePanel(this, msg);
         message.butOK.setVisible(false);
         this.owInterface.ChangePanel(message);
      }
      e.printStackTrace();
    }//end try



  }//end next step





  /**
   * to do final calculation of the OW test result
   */
  public void calculateTotal(){
    this.processingMeasure =0; //correct answer of true and false
    this.setSizeMemorySpan = 0;
    for (int i=0;i<totalTestItem;i++){
      if(trueFalseList[i] == trueFalseReply[i]){
        this.processingMeasure++;
      }
    }//end for
//***********************

     int itemSoFar = 0; //current set number amount totalTestItem (6)

    //for correct words, correct position, and all words in the set are corrected recalled
     for (int i=0;i<15;i++){
        Vector real = new Vector(this.serSize[i]); //real words vector for Word's list
        Vector user = new Vector(this.serSize[i]); //words user input

        for(int j=0;j<this.serSize[i];j++){
          real.addElement(wordList[itemSoFar + j]);
          user.addElement(wordReply[itemSoFar + j]);
        }
        if(this.compare(real, user)){ //if the user's word is correct
          this.setSizeMemorySpan = Math.max(this.setSizeMemorySpan, this.serSize[i]);
          this.totalMemorySpan += this.serSize[i];
        }

        itemSoFar = itemSoFar + this.serSize[i];
     }//end for i

     itemSoFar = 0;
     //for correct words, correct position, but not all words in the set are corrected recalled
     for (int i=0;i<15;i++){
        Vector real = new Vector(this.serSize[i]); //real words vector for Word's list
        Vector user = new Vector(this.serSize[i]); //words user input

        for(int j=0;j<this.serSize[i];j++){
          real.addElement(wordList[itemSoFar + j]);
          user.addElement(wordReply[itemSoFar + j]);
        }
        this.partialCorrectWords += this.comparePartial(real, user);
        itemSoFar = itemSoFar + this.serSize[i];
     }//end for i



    if(debug){
      System.out.println("For opeartions' answers:\n");
      for(int i=0;i<totalTestItem;i++){
        System.out.println("trueFalseList:" + this.trueFalseList[i] + " trueFalseReply:" + this.trueFalseReply[i]);
      }
      System.out.println("processing measure:" + this.processingMeasure);
      System.out.println("Total Memory Span:" + this.totalMemorySpan);
      System.out.println("Setsize Memory Span:" + this.setSizeMemorySpan);
    }

    //the first display's latency is not counted as the time to load the applet may vary
    averageLatency =Math.round (this.totalLatency / (this.totalTestItem));

    if(this.studentID.compareTo("1")!=0){
      //block student from re do the test again
      String query = "select * from usertests where userID='" + this.studentID +
        "'";
      ResultSet rs = db.getResultSet(query);
      try {
        //if (!rs.wasNull()) {
        if (rs.next()) {
          if (this.debug)
            System.out.println("Student already tested.");
          return;
        }
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }//end if 1

    java.util.Date aDate = new java.util.Date();
    //String dateString = aDate.getYear() + "." + aDate.getMonth() +"." + aDate.getDate() + " " + aDate.getHours() + ":" + aDate.getMinutes();
    String dateString = aDate.toString();

    String query = "insert into usertests (userID, processmeasure, totalmemoryspan, setsizememoryspan, meanresponselatency, completeTime, partialCorrectMemorySpan) values('" +
      this.studentID + "'," + this.processingMeasure + ", " +
      this.totalMemorySpan +
      ", " + this.setSizeMemorySpan + "," + averageLatency + ",'" + dateString +
      "'," + this.partialCorrectWords +
      ")";
    //System.out.println(query);

    db.executeUpdate(query);

    //do something here










  }//end calulateAll

  /**
   * compare 2 string vectors, 2 vector size must be the same
   * each item in v1 is unique, every item in v2 is also unique
   * @param v1
   * @param v2
   * @return true if two vectors have the same string in the same order
   * */
  boolean compare(Vector v1, Vector v2){
    if(v1.size() != v2.size()){
      System.out.println("2 vectors are different size, cannot compare");
      System.exit(0);
    }
    for(int i=0;i<v1.size();i++){
      String s1 = (String)v1.elementAt(i); //need to check
      String s2 = (String)v2.elementAt(i);
      if (s1.compareToIgnoreCase(s2) != 0) { //match
        if (debug) {
          for (int j = 0; j < v1.size(); j++) {
            System.out.println("wordList:" + v1.elementAt(j) +
                               " replyWordList:" + v2.elementAt(j));
          }
        }

        System.out.println("Wrong Wrods\n\n");
        return false;
      }
    }//end for i

    if(debug){
      for(int i=0;i<v1.size();i++){
        System.out.println("wordList:" + v1.elementAt(i) + " replyWordList:" + v2.elementAt(i));
      }
    }
    System.out.println("Correct Words\n\n");
    return true;
  }//end compare


  /**
   * compare 2 string vectors, 2 vector size must be the same
   * each item in v1 is unique, every item in v2 is also unique
   * @param v1
   * @param v2
   * @return the number of strings that are correct in their position and correct spelling
   * */
  int comparePartial(Vector v1, Vector v2){
    if(v1.size() != v2.size()){
      System.out.println("comparePartial: 2 vectors are different size, cannot compare");
      System.exit(0);
    }
    int totalCorrect=0;
    for(int i=0;i<v1.size();i++){
      String s1 = (String)v1.elementAt(i); //need to check
      String s2 = (String)v2.elementAt(i);
      if (s1.compareToIgnoreCase(s2) != 0) { //not matching (
      //if (s1.compareTo(s2) != 0) { //not matching
        if (debug) {
          for (int j = 0; j < v1.size(); j++) {
            System.out.println("wordList:" + v1.elementAt(j) +
                               " replyWordList:" + v2.elementAt(j));
          }//end for
        }//end if
        System.out.println("Wrong Wrods\n\n");

      }//end not match
      else{//matching
        totalCorrect++;
      }
    }//end for i

    if(debug){
      for(int i=0;i<v1.size();i++){
        System.out.println("wordList:" + v1.elementAt(i) + " replyWordList:" + v2.elementAt(i));
      }
    }
    System.out.println("Correct Words\n\n");
    return totalCorrect;
  }//end comparePartial






}//end class
